<template>
  <div class="items">
    <h1>Items</h1>
    <a-row :gutter="[16, 16]">
      <ItemCard v-for="i in items" :key="i.id" v-bind:item="i" />
    </a-row>
  </div>
</template>

<script lang="ts">
import { Component, Vue } from "vue-property-decorator";
import { Item } from "@/interfaces/interfaces";
import ItemService from "@/services/ItemService";
import ItemCard from "@/components/ItemCard.vue";

@Component({
  components: {
    ItemCard
  }
})
export default class Items extends Vue {
  private items: Array<Item> = [];

  created() {
    this.getItems();
  }

  private async getItems() {
    const itemService = new ItemService();
    await itemService
      .GetAllItems()
      .then(data => {
        this.setItems(data);
      })
      .catch(err => {
        console.log(err);
        alert(err);
      });
  }

  private setItems(items: Array<Item>) {
    items.forEach(i => this.items.push(i));
  }
}
</script>
